//#include "stdafx.h"
#include <stdio.h>
#include <string.h>


#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32
#include <conio.h>
#include <windows.h>
#include <stdlib.h>
#include <mmsystem.h>
#include <math.h>
#define strncasecmp _strnicmp 
#include <winioctl.h>

#endif

#ifdef WIN32
#define DSCUDAPICALL __declspec(dllexport)
TCHAR port_name[10];
//DSCUDAPICALL HANDLE hPortHandle;
#else /* WIN32 not defined */
#include "fcntl.h"
#include "unistd.h"
#include "math.h"
#define DSCUDAPICALL
#endif /* #ifdef WIN32 */

typedef struct 
{
	double Voltage[3];// Array index 0,1,2 holds voltage value of 12V,5V and 3.3V source respectively 
	double Current[3];// Array index 0,1,2 holds current value of 12V,5V and 3.3V source respectively 
	double Power[3];  // Array index 0,1,2 holds Power value of 12V,5V and 3.3V source respectively 

}JMM5000RegulatorValues;

JMM5000RegulatorValues getvalues;

typedef struct
{
	char *error_string;
}ERRORPARAMS;

ERRORPARAMS error;


//Window variable declarations
#ifdef WIN32
#include "SerialPortFunction.h"
#define ERROR_SERIAL_OPEN	0x1
#define ERROR_SERIAL_WRITE  0x2
#define ERROR_SERIAL_READ	0x3

#define POLICY_KEY TEXT("HARDWARE\\DEVICEMAP\\SERIALCOMM")
#define lpValueName1 TEXT("\\Device\\USBSER000") 
int SerialPortinit();

#endif


//int DSCUDAPICALL JMM5000Status(unsigned char* status);
int DSCUDAPICALL JMM5000Write(unsigned char data);
int DSCUDAPICALL JMM5000Read(unsigned char* data);
int DSCUDAPICALL JMM5000_LED(unsigned char data);//JMM5000LED
int DSCUDAPICALL JMM5000_DIOWrite(unsigned char port, int data);//JMM5000DIOWrite
int DSCUDAPICALL JMM5000_DIORead(unsigned char port,int *data);//JMM5000DIORead
int DSCUDAPICALL JMM5000DIOConfigure(unsigned char port,int configuration);
int DSCUDAPICALL JMM5000LTC2974Command(unsigned char command, char *data);
int DSCUDAPICALL JMM5000_ResetControl();//JMM5000ResetLTC2947(); 
int DSCUDAPICALL JMM5000_ResetPIC();//JMM5000ResetPIC(); 
int DSCUDAPICALL JMM5000_PowerControl(unsigned char data);//JMM5000PowerControl
int DSCUDAPICALL JMM5000_PowerCycleControl(unsigned char data);//JMM5000PowerCycleControl
int DSCUDAPICALL JMM5000_LEDStatus(unsigned char* data);//JMM5000LEDStatus

//int DSCUDAPICALL SerialPortinit();
void DSCUDAPICALL DSCGetLastError(ERRORPARAMS *error_params);
int DSCSetLastError(int error);

int L_16format(unsigned char page,unsigned char cmd,double *data);
int L_11format(unsigned char page,unsigned char cmd,double *data);
int DSCUDAPICALL JMM5000_Init();
int DSCUDAPICALL JMM5000_Close();
int DSCUDAPICALL JMM5000_PowerCycleTime(int data);//JMM5000PowerCycleTime
int DSCUDAPICALL JMM5000_PowerOnTime(int data);//JMM5000PowerOnTime
int DSCUDAPICALL JMM5000_Status(unsigned char* data);//JMM5000RequestStatus
int DSCUDAPICALL JMM5000_ControlWrite(int command,int page_enable,int page,int data);//JMM5000LTC2974WriteCommand
int DSCUDAPICALL JMM5000_ControlRead(int Command,int PageEnable, int  page,int* data);//JMM5000LTC2974ReadCommand
int DSCUDAPICALL JMM5000_ControlReadRawCurrent(int PageEnable,int page,int* data);
int DSCUDAPICALL JMM5000_ControlEERead(unsigned char command,int PageEnable,unsigned char page,int *data);//JMM5000LTC2974EEPROMRead
int DSCUDAPICALL JMM5000_ControlEEWrite(unsigned char command,int PageEnable,unsigned char page,int data);//JMM5000LTC2974EEPROMWrite
int DSCUDAPICALL JMM5000_InputConfigStore(unsigned char control_data,unsigned char data);//JMM5000PotentiometerWrite
int DSCUDAPICALL JMM5000_ConfigFlashRead(unsigned char *value);
int DSCUDAPICALL JMM5000_InputConfigRead(unsigned char cmd,unsigned char data,unsigned char *value);
int DSCUDAPICALL JMM5000_InputConfig(int Selection,float LowerVoltage ,float UpperVoltage);//JMM5000PrimaryInputVoltageRangeSelection
int DSCUDAPICALL JMM5000_OutputStatus(JMM5000RegulatorValues* parameter);//JMM5000ReadbackAllVoltageCurrentPower
int Serial_Write(unsigned char *data_to_write,int buffersize,unsigned long length);
int Serially_Read(unsigned char *read_buff,int num_to_read);
int DSCUDAPICALL JMM5000_ADRead(int channel, float *voltage);
int DSCUDAPICALL JMM5000_ControlInitialize(float *values);

void DSCUDAPICALL JMM5000_Double_To_L11(double value,int *final_value);
void DSCUDAPICALL JMM5000_Double_To_L16(double value,int *final_value);
int DSCUDAPICALL L16format_To_Double(int value,double *data);
int DSCUDAPICALL L11format_To_Double(int value,double *data);

int DSCUDAPICALL JMM5000_StoreNoLoadCurrent(int page,int data);
int DSCUDAPICALL JMM5000_Store_TON_Delay_To_Flash(char page,int data);
int DSCUDAPICALL JMM5000_Store_TON_Rise_To_Flash(char page,int data);
int DSCUDAPICALL JMM5000_Store_TON_Max_To_Flash(char page,int data);
int DSCUDAPICALL JMM5000_Store_TOFF_Delay_To_Flash(char page,int data);

int DSCUDAPICALL JMM5000_Read_TON_Delay_From_Flash(int* data);
int DSCUDAPICALL JMM5000_Read_TON_Rise_From_Flash(int* data);
int DSCUDAPICALL JMM5000_Read_TON_Max_From_Flash(int* data);
int DSCUDAPICALL JMM5000_Read_TOFF_Delay_From_Flash(int* data);
void JMM5000_Round(double data_recvd,int *integer_data);

int DSCUDAPICALL JMM5000_Store_JMM5000Series_Details(int data);
int DSCUDAPICALL JMM5000_Read_JMM5000Series_Details(int *series);

#ifdef __cplusplus
} /* Closes the extern "C" */
#endif
